st7/
	
	#INCLUDE "st7flite19.inc"
	#INCLUDE "1wire.inc"
	
	

	BYTES
	SEGMENT 'ram0'
.ptrRead		ds.w	1
.ptrWrite		ds.w  1
.numptr			DS.w  1

.numer.w		DS.B	8
.crc				ds.b	1

	WORDS
	SEGMENT	'rom'


;******************************************************************************
; Procedura zapisujca kod do pamici EEPROM
;******************************************************************************
.registerCode		
		CALL	owreset									; reset
		JRC		registerCode						; jesli brak impulsu obecnoci to skok na pocztek
		LD		A, #$33									; READ ROM	
		CALL	owwrite	
		CALL	readnumer
		CALL	crc8
		LD		A, numer
		JREQ	registerCode						; jeli FAMILY CODE = 0 to skok na pocatek
		LD		A,crc
		JRNE	registerCode						; jeli CRC != 0 to skok na pocztek
		BSET	EECSR, #EECSR_E2LAT			; E2LAT = 1 -> Zapis do EEPROM
		CALL	copyNumer								; skopiowanie numeru z RAM do obszaru EEPROM
		BSET	EECSR, #EECSR_E2PGM			; E2PGM = 1 -> wyzwolenie procesu programowania
		BTJT	EECSR, #EECSR_E2PGM, *	; oczekiwanie na zakoczenie procesu programowania
		RET

		
;******************************************************************************
; Procedura obliczajca CRC8 jednego bajtu
;******************************************************************************
.crc8byte
		;PUSH	A
		PUSH	X										; zapamitanie X na stosie	
		PUSH	A										; zapamitanie A na stosie		
		LD		X, #8								; ilos bitw
crc81
		XOR		A, crc							; A = dane ^ crc	
		RRC		A										; A >> 1
		LD		A, crc							; A = crc 
		JRNC	crc82								; jeli C to A ^ 0x18
		XOR		A, #$18
crc82		
		RRC		A										; A >> 1
		LD		crc, A							; zapamietanie biecej wartoci CRC
		POP		A										; odtworzenie danej wejciowej		
		SRA		A										; przygotowanie nastepnego bitu
		PUSH	A										; zapamietanie na stosie		
		DEC		X										; zmniejszenie licznika ptli
		JRNE	crc81								; jeli > 0 to skok do crc81			
		POP		A										; w przeciwnym razie odtworzenie A
		POP		X										; oraz X
		;POP		A
		RET												; powrt z procedury
		
;******************************************************************************
; Procedura obliczajca CRC8 8-bajtowego obszaru pamieci
;******************************************************************************
.crc8
		PUSH	X										; zapamietanie X na stosie
		CLR		X										; wyzerowanie X		
		CLR		crc									; wyzerowanei crc
crcloop
		LD		A, ([numptr.w],X)		; zaadowanie bajtu
		CALL	crc8byte						; obliczenie CRC8
		INC		X										; przygotowanie nastpnego bajtu			
		CP		X, #8								; sprawdzenie czy to juz koniec
		JRNE	crcloop							; jeli nie to skok do crcloop
		POP		X										; w przeciwnym razie odtworzenie X
		RET	

;******************************************************************************
; Procedura odczytujaca numer seryjny ukadu 1wire
;******************************************************************************
.readnumer		
		PUSH	X
rnloop		
		CLR		X										; wyzerowanie X
readloop		
		CALL	owread							; odczyt bajtu adresu
		LD		([numptr.w],X),A		; zapamitanie 
		INC		X										; przygotowanie kolejnej pozycji
		CP		X, #8								; sprawdzenie czy ju koniec
		JRNE	readloop						; jeli nie to skok do readloop
		POP		X										; w przeciwnym razie odtworzenie X
		RET												; i powrt z procedury
		
;******************************************************************************
; Procedura zapisujaca numer seryjny ukadu 1wire
;******************************************************************************		
.writenumer
		PUSH	X
		CLR		X
wnloop
		LD		A,([ptrRead.w],X)
		CALL	owwrite
		INC		X
		CP		X, #8
		JRNE	wnloop
		POP		X
		RET
		
;******************************************************************************
; Procedura kopiujca numer seryjny ukadu 1wire z RAM do EEPROM
;******************************************************************************
.copyNumer
		PUSH	X										; zapamianie X na stosie
		CLR		X										; wyzerowanie licznika ptli
copyLoop
		LD		A, ([numptr.w],X)		; odczytanie bajtu z pamici RAM
		LD		([ptrWrite.w],X), A	; zapisanie bajtu do pamici EEPROM
		INC		X										; zwikszenie licznika ptli
		CP		X, #8								; sprawdzenie czy licznik = 8
		JRNE	copyLoop						; jeli nie, to skok na pocztek ptli
		POP		X										; odtworzenie zawartoi X ze stosu
		RET
		
		
		END
		