st7/
;******************************************************************************
; LITEcomp - aplikacje
; Zegar z ukadem PCF8583
;******************************************************************************

    .nolist	
		#INCLUDE "st7flite19.inc"
		#INCLUDE "LCD.inc"
		#INCLUDE "I2C.inc"
    .list       
	
S1	EQU	0
S2	EQu	2



TIME_HOME EQU	0
DATE_HOME EQU	11

;******************************************************************************
; obszar pamici danych RAM
;******************************************************************************	
		BYTES
		segment	'ram0'
; zmienne dla procedur zwizanych z czasem i dat
godziny		DS.B 1
minuty		DS.B 1
sekundy		DS.B 1
packdate	DS.B 2
dni				DS.B 1
miesiace	DS.B 1
dnityg		DS.B 1
; zmienne zwizane z procedurami wprowadzania 
; czasu i daty przez uytkownika
czas			DS.B	16 
cursor		DS.B 1 
menupos		DS.B 1		


;******************************************************************************
; obszar pamieci programu		
;******************************************************************************
		WORDS
		segment 'rom'
tekst1	DC.B	"   www.btc.pl   ", 0
tekst2	DC.B	"    LITEcomp",0
tekst3	DC.B	" ST7 & PCF8583",0

;******************************************************************************
; pocztek programu gwnego
;******************************************************************************
._reset
		RSP
		LD		X, #0						;
initcz										
		CLR		(czas,X)				; wyzerowanie zmiennej czas
		INC		X								;
		CP		X, #16					;
		JRNE	initcz					;
		
		LD		A, #%00000000
		LD		PBDDR, A
		LD		A, #%00000001
		LD		PBOR, A
		LD 		A, #%11111010	 	
    LD 		PADDR, A 
    LD 		A, #%11111111	
    LD 		PAOR, A  
		LD		A, #%10000000
		LD		EICR, A
		CLR 	PBDR
		CLR		menupos
		CLR		cursor

		CALL	lcdinit					; inicjalizacja wyietlacza
		
		WTXT	tekst2					;
		LD		A, #$40					; Wywietlenie ekranu startowego
		CALL	lcdsetaddress		;
		WTXT	tekst3					;
		
		BTJT	PBDR,#0, *			; Oczekiwanie na 2 zmiany stanu na linii INT
		BTJF	PBDR,#0, *			; (odmierzenie 1 sek.)
		BTJT	PBDR,#0, *			;
		
		LD		A, #$01					; wyczyszenie zawartoci ekranu
		CALL	writecommand		;
		
		LD		A, #$40					; ustawienie adresu drugiej linii
		CALL	lcdsetaddress		; 
			
		WTXT	tekst1					; wywietlenie tekstu w dolnej linii wywietlacza
		
		RIM										; zezwolenie na przerwania
		
.mainloop 								; ptla nieskoczona
		BTJT	PADR,#S1, ml1 	; jeli przycisk zwolniony to skok do ml1
		CALL	s1_push 				; w przeciwnym razie wywoanie procedury obsugi przycisku S1
		BTJF	PADR,#S1,*			; oczekiwanie na zwolnienie przycisku
ml1
		BTJT	PADR,#S2, ml2 	; jeli przycisk zwolniony to skok do ml2
		CALL	s2_push 				; w przeciwnym razie wywoanie procedury obsugi przycisku S2
		BTJF	PADR,#S2,* 			; oczekiwanie na zwolnienie przycisku
ml2
		JRA mainloop					; skok na pocztek ptli
		
;******************************************************************************
; Procedura reakcji na nacinicie przycisku S1
;******************************************************************************
.s1_push
		LD		A, menupos 			; zaadowanie do A pozycji menu
		CP		A, #0 					; porwnanie z wartosci
		JRNE 	s1p1 						; jeli rzne skok do s1p1
		CALL	settime 				; w przeciwnym razie wywoanie procedury ustawiania czasu
		INC 	menupos 				; i zwikszenie pozycji menu
s1p1
		CP		A, #1 					; porwnanie z wartoci 
		JRNE 	s1p2 						; jeli rzne skok do s1p2
		CALL 	shiftcursor 		; przesunicie kursora
		LD		A, cursor 			; zaadowanie pozycji kursora
		CP		A, #16 					; porwnanie z wartoci
		JRNE	s1p2 						; jeli rzne skok do s1p2
		CALL	endtime 				; w przeciwnym razie zakoczenie trybu ustawiania daty
s1p2		
		RET
;******************************************************************************
; Procedura reakcji na nacicnicie przycisku S2
;******************************************************************************
.s2_push
		CALL	inctemptime 		; modyfikacja ustawionego czasu
		RET
;******************************************************************************
;	Procedura ustawiajca kursor wywietlacza na pozycji okrelonej zmienn cursor
;******************************************************************************
.setcursor
		LD		A, #%10000000 	; SET DDRAM
		RCF 									; zerujemy flag C
		ADD		A, cursor 			; dodajemy pozycj kursora
		CALL	writecommand		; zapis komendy
		RET
;******************************************************************************
; Procedura ustawienia czasu
;******************************************************************************
.inctemptime
		LD		X, cursor 			; zaadowanie do X pozycji kursora
		INC		(czas,X) 				; inkrementacja komrki pamici wskazywanej przez kursor
		LD		A,(czas,X)
		CP		A,#10 					; sprawdzenie czy > 9
		JRNE	inctt1					; jeli nie to skok do inctt1
		CLR		(czas,X) 				; w przeciwnym razie wyzerowanie
inctt1		
		CALL	cursoroff 			; wyaczenie wywietlania kursora
		CALL  disptemptime 		; wyswietlenie ustawianego czasu
		CALL	setcursor 			; ustawienie kursora
		CALL  cursoron 				; waczenie kursora
		RET
;******************************************************************************
; Procedura przesuwajca kursor na wywieltaczu w prawo
;******************************************************************************
.shiftcursor
		INC 	cursor 					; inkrementacja pozycji kursora
		CALL	setcursor 			; ustawienie kursora na pozycji
		RET
;******************************************************************************
; Procedura wywietlajca ustawiany czas
;******************************************************************************
.disptemptime
		LD		A, #TIME_HOME
		CALL	lcdsetaddress
		LD		A, {czas + 0}
		ADD		A, #'0'
		CALL	writedata
		LD		A, {czas + 1}
		ADD		A, #'0'
		CALL	writedata
		LD		A, #':'
		CALL	writedata
		LD		A, {czas + 3}
		ADD		A, #'0'
		CALL	writedata
		LD		A, {czas + 4}
		ADD		A, #'0'
		CALL	writedata
		LD		A, #':'
		CALL	writedata
		LD		A, {czas + 6}
		ADD		A, #'0'
		CALL	writedata
		LD		A, {czas + 7}
		ADD		A, #'0'
		CALL	writedata
		LD		A, #' '
		CALL	writedata
		LD		A, #' '
		CALL	writedata
		LD		A, #' '
		CALL	writedata
		LD		A, {czas + 11}
		ADD		A, #'0'
		CALL	writedata
		LD		A, {czas + 12}
		ADD		A, #'0'
		CALL	writedata
		LD		A, #'/'
		CALL	writedata
		LD		A, {czas + 14}
		ADD		A, #'0'
		CALL	writedata
		LD		A, {czas + 15}
		ADD		A, #'0'
		CALL	writedata
		RET
;******************************************************************************
; Procedura rozpoczynajaca tryb ustawiania czasu
;******************************************************************************
.settime
		SIM 									; zablokowanie przerwa
		CALL	disptemptime 		; wywietlenie ustawianego czasu
		CALL	lcdhome 				; LCD HOME
		CALL	cursoron 				; waczenie kursora
		CLR		cursor 					; wyzerowanie pozycji kursora
		RET
;******************************************************************************
; Procedura koczca tryb ustawiania czasu
;******************************************************************************
.endtime
		CALL	packtime 				; spakuj czas
		CALL	writetime 			; zapisz czas
		CALL	cursoroff 			; wycz migotanie i kursor
		CLR		cursor 					; wyzerowanie pozycji kursora
		CLR		menupos 				; wyzerowanie pozycji menu
		RIM 									; odblokowanie przerwa
		RET
		
;******************************************************************************
; Procedura odczytujaca czas i dat z ukadu PCF8583
;******************************************************************************		
.readtime
		CALL	i2c_start 			; start transmisji
		LD		A, #$A0 				; 
		CALL	i2c_write 			; zapis adresu ukadu PCF8583
		LD		A, #$02
		CALL	i2c_write 			; zapis adresu rejestru wewntrznego
		CALL	i2c_start 			; ponowny start
		LD		A, #$A1 				; zapis adresu ukadu PCF8583 + R
		CALL	i2c_write
		RCF										; ACK
		CALL	i2c_read 				; odczyt wartoci sekund
		LD		sekundy, A	
		RCF										; ACK
		CALL	i2c_read				; odczyt wartoci minut
		LD		minuty, A
		RCF										; ACK
		CALL	i2c_read 				; odczyt wartoci godzin
		LD		godziny, A
		RCF										; ACK
		CALL	i2c_read 				; odczyt wartoci daty
		LD		{packdate+0}, A
		SCF										; NACK
		CALL	i2c_read 				; odczyt wartoci daty
		LD		{packdate+1}, A
		CALL	i2c_stop 				; stop transmisji
		RET
		
;******************************************************************************
; Procedura rozpakowywujca dat
;******************************************************************************
.unpackdate
		LD		A,{packdate+0} 	; zaadowanie do A pierwszego bajtu spakowanej daty
		AND		A, #%00111111 	; wyzerowanie numeru roku
		LD		dni, A 					; zapis wartoci dnia
		
		LD		A,{packdate+1} 	; zaadowanie do A drugiego bajtu spakowanej daty
		AND		A, #%00011111 	; wyzerowanie dnia tygodnia
		LD		miesiace, A 		; zapis wartoci miesica
		
		LD		A,{packdate+1}	; zaadowanie do A drugiego bajtu spakowanej daty
		SWAP	A 							; zamiana pbajtw
		SRA		A 							; przesunicie o 1 bit w prawo
		AND		A, #%00000111		; wyzerowanie nieznaczcych bitw
		LD		dnityg, A				; zapis wartoci dnia tygodnia
		RET
;******************************************************************************
; Procedura wywietlajaca aktualny czas
;******************************************************************************
.disptime
		CALL	lcdhome
		LD		A, godziny 
		CALL	writebcd 				; wywietlamy godziny
		LD		A, #':'
		CALL	writedata 			; wywietlamy dwukropek
		LD		A, minuty 
		CALL	writebcd 				; wywietlamy minuty
		LD		A, #':'
		CALL	writedata 			; wywietlamy dwukropek
		LD		A, sekundy
		CALL	writebcd 				; wywietlamy sekundy
		CALL	unpackdate 			; rozpakowanie daty
		LD		A, #DATE_HOME
		CALL	lcdsetaddress 	; ustawienie adresu
		LD		A, dni 
		CALL	writebcd 				; wywietlenie dnia
		LD		A, #'/'
		CALL	writedata 			; wywietlenie ukonika
		LD		A, miesiace
		CALL	writebcd 				; wywietlenie miesica
		RET

;****************************************************************************** 
; Procedura przeksztacajca wprowadzony czas  i dat
; na format rejestrw ukadu PCF8583
;******************************************************************************
.packtime
		LD		A, {czas+0} 		; do A adujemy dziesitki godzin
		SWAP	A 							; zamiana pbajtw
		OR		A, {czas+1} 		; suma logiczna z jednostkami godzin
		LD		godziny, A  		; adujemy do godzin
		
		LD		A, {czas+3} 		; do A adujemy dziesitki minut
		SWAP	A								; zamiana pbajtw
		OR		A, {czas+4} 		; suma logiczna z jednostkami minut
		LD		minuty, A 			; adujemy do minut
		
		LD		A, {czas+6} 		; do A adujemy dziesitki sekund
		SWAP	A 							; zamiana pbajtw
		OR		A, {czas+7} 		; suma logiczna z jednostkami sekund
		LD		sekundy, A 			; adujemy do sekund
		
		LD		A, {czas+11} 		; do A adujemy dziesitki dni
		SWAP	A 							; zamiana pbajtw
		OR		A, {czas+12} 		; suma logiczna z jednostkami dni
		LD		dni, A 					; adujemy do dni
		
		LD		A, {czas+14} 		; do A adujemy dziesiatki miesicy
		SWAP	A 							; zamiana pbajtw
		OR		A, {czas+15} 		; suma logiczna z jednostkami miesicy
		LD		miesiace,A 			; adujemy do miesicy
		RET
		
;****************************************************************************** 
; Procedura zapisujaca ustawiony czas i dat do ukadu PCF8583
;******************************************************************************
.writetime
		CALL	i2c_start 			; start transmisji
		LD		A, #$A0 				; adres ukadu
		CALL	i2c_write 			; zapis
		LD		A, #$00 				; adres rejestru wewntrznego ukadu PCF8583
		CALL	i2c_write 			; zapis
		LD		A, #$80 				; zatrzymanie odlicznaia czasu
		CALL	i2c_write
		LD		A, #$00 				; z
		CALL	i2c_write
		LD		A, sekundy  
		CALL	i2c_write				; zapis sekund
		LD		A, minuty
		CALL	i2c_write 			; zapis minut
		LD		A, godziny
		CALL	i2c_write 			; zapis godzin
		LD		A, dni
		CALL	i2c_write 			; zapis dni
		LD		A, miesiace
		CALL	i2c_write 			; zapis miesicy
		CALL	i2c_stop  			; stop
		
		CALL	i2c_start 			; start
		LD		A, #$A0 
		CALL	i2c_write 			; adres ukadu
		LD		A, #$00 				; adres rejestru wewntrzego
		CALL	i2c_write
		LD		A, #$00 				; waczenie odliczania czasu
		CALL	i2c_write
		CALL	i2c_stop 				; stop
		RET

;******************************************************************************
; Procedura obsugi przerwania zewntrznego (co 1 sekund)
; W ramach procedury realizowany jest odczyt aktualnych wartoci
; daty i czasu, oraz ich wywietlenie na wywietlaczu LCD
;******************************************************************************
._ei3_vect
		CALL	readtime				; odczyt czasu i daty
		CALL	disptime 				; wywietlenie czasu i daty
		IRET
 
		end
;******************************************************************************
; Koniec pliku main.asm
;******************************************************************************		