st7/

		.NOLIST	
		#INCLUDE "st7flite19.inc"
    .LIST 
		
		#define RC5Port		PBDR
		#define	RC5Pin		#6
		
		#define RC5ErrS1	#7
		#define RC5ErrS20	#6
		#define RC5ErrS21	#5
		#define RC5Toggle #1
		#define RC5Ready	#0

;******************************************************************************
; obszar pamici danych RAM
;******************************************************************************	
		BYTES
		segment 'ram0'
.tickCount 		ds.b 	1 ; licznik wystpie przerwania od timera
.RC5Command		ds.b 	1	; odebrany rozkaz RC5
.RC5Address		ds.b	1	; odebrany adres RC5
.RC5Status		ds.b	1 ; status 
RC5StatusT		ds.b	1	; status pomocniczy
		
;******************************************************************************
; obszar pamieci programu		
;******************************************************************************				
		WORDS
		segment 'rom'
		
;******************************************************************************
; Procedura oczekiwania na odebranie kodu RC5
;******************************************************************************		
.WaitForRC5
		BTJF	RC5Status, RC5Ready, *	; oczekiwanie na ustawienie flagi RC5READY
		BRES	RC5Status, RC5Ready			; wyzerowanie flagi RC5READY
		RET

;******************************************************************************
; przerwanie zewntrzne od RC5
; wywoywane przez pocztek ramki sygnau RC5
;******************************************************************************
._EI2Vect
		CLR		RC5Command							; wyzerowanie poprzednio odebranego rozkazu
		CLR		RC5Address							; wyzerowanie poprzednio odebranego adresu
		LD		A, #%10100000						;
		LD		RC5Status, A						; ustawienie pocztkowej wartoci bajtu statusu
		BRES	PBOR, RC5Pin 						; zablokowanie przerwania zewntrznego
		LD		A, #18 									; waczenie timera oraz zezwolenie na 
		LD		ATCSR, A								; przerwanie od jego przepenienia
		IRET

;****************************************************************************** 
; przerwanie od przepenienia AT Timera
; co 444us dla F = 16MHz
;******************************************************************************
._ATOvfVect
		LD		A, ATCSR 							; zerowanie flagi przerwania
		INC 	tickCount 						; zwikszenie licznika wystpie przerwania
		LD		A, tickCount					;
		CP		A, #57								; czy to ju koniec ramki?
		JREQ	EndFrame							; jeli tak to skok do EndFrame
		BTJT	RC5Port, RC5Pin, Exit	; jeli wejcie RC5 jest w stanie wysokim 
																; to skok do Exit
; w przeciwnym razie....
StartFrame
;
;Pocztek ramki sygnau RC5
; 
BitS1		; bit S1
		CP		A, #1
		JRNE	BitS20
		BRES	RC5Status, RC5ErrS1
		IRET
BitS20 ; pierwsza powka bitu S2
		CP		A, #3
		JRNE	BitS2
		BSET	RC5Status, RC5ErrS20
		IRET
BitS2	; druga powka bitu S2
		CP		A, #5
		JRNE	BitT
		BRES	RC5Status, RC5ErrS21
		IRET
BitT	; bit T
		CP		A, #9
		JRNE	BitA4
		BSET 	RC5Status, RC5Toggle
		IRET
BitA4 ; bit A4
		CP		A,#13
		JRNE	BitA3
		BSET	RC5Address, #4
		IRET
BitA3 ; bit A3
		CP		A,#17
		JRNE	BitA2
		BSET	RC5Address, #3
		IRET
BitA2 ; bit A2
		CP		A,#21
		JRNE	BitA1
		BSET	RC5Address, #2
		IRET
BitA1 ; bit A1
		CP		A, #25
		JRNE	BitA0
		BSET	RC5Address, #1
		IRET
BitA0 ; bit A0
		CP		A, #29
		JRNE	BitC5
		BSET	RC5Address, #0
		IRET
BitC5 ; bit C5
		CP		A, #33
		JRNE	BitC4
		BSET	RC5Command, #5
		IRET
BitC4 ; bit C4
		CP		A, #37
		JRNE	BitC3
		BSET	RC5Command, #4
		IRET
BitC3 ; bit C3
		CP		A, #41
		JRNE	BitC2
		BSET	RC5Command, #3
		IRET
BitC2 ; bit C2
		CP		A, #45
		JRNE	BitC1
		BSET	RC5Command, #2
		IRET
BitC1 ; bit C1
		CP		A, #49
		JRNE	BitC0
		BSET	RC5Command, #1
		IRET
BitC0 ; bit C0
		CP		A, #53
		JRNE	EndFrame
		BSET	RC5Command, #0
Exit
		IRET
EndFrame ; koniec ramki sygnau RC5
		LD		A, tickCount 
		CP		A, #57							; sprawdzenie, czy aby na pewno
		JRNE	Exit								; jeli nie to skok do Exit
		CLR		tickCount						; wyzerowanie licznika wystpie przerwania
		CLR		ATCSR								; zatrzymanie timera
		
				
		LD		A, RC5Status
		AND		A, #%00000010
		CP		A, RC5StatusT
		JREQ	NoReady
		LD		RC5StatusT, A
		
		LD		A, RC5Status
		AND		A, #%11100000 			; sprawdzenie czy wystpiy bedy
		JRNE	NoReady 						;jeli tak to skok do NoReady
		BSET	RC5Status, RC5Ready ; w przeciwnym razie ustawienie flagi gotowoci
NoReady		
		BSET	PBOR, RC5Pin 				; zezwolenie na przerwanie zewntrzne
		JRA		Exit
		
;******************************************************************************
; Inicjalizacja ukadw prefyferyjnych i zmiennych
;******************************************************************************		
.RC5Init
		LD 		A, #%00000000					; cay port pracuje jako wejcie
		LD		PBDDR, A
		LD		A, #%01000000					; na PB6 waczony pull-up
		LD		PBOR, A
		LD		A, #%00100000					;
		LD		ATRL, A 							; przepenienie timera co 444us
		LD		A, #%00000010					;
		LD		ATRH, A 							;
		LD		A, #%00100000					;
		LD		EICR,A								;
		LD		A, #%00110000					; Konfiguracja przerwa zewntrznych
		LD		EISR, A								;
		LD		A, #0
		LD		tickCount, A					;
		LD		RC5Status, A					;	
		LD		RC5Command, A					; Inicjalizacja zmiennych
		LD		RC5Address, A					;
		RET		
		END
		